﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Media.Animation;
using C1.WPF.Theming;

namespace C1Expander
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            Application.Current.Resources.MergedDictionaries.
                Add(C1Theme.GetCurrentThemeResources(new C1.WPF.Theming.ExpressionDark.C1ThemeExpressionDark()));

        }

        private void c1Expander_IsExpandedChanging(object sender, C1.WPF.PropertyChangingEventArgs<bool> e)
        {
           if (e.NewValue == true)            
           {
                DoubleAnimation widthAnimation = new DoubleAnimation(100, 200, new Duration(TimeSpan.FromSeconds(5)));
                widthAnimation.SpeedRatio = 3;
                widthAnimation.AutoReverse = true;
                // Create a clock from the animation.
                var myControllableClock = widthAnimation.CreateClock();
                // Apply the clock to the rectangle's Width property.
                c1Expander.ApplyAnimationClock(Rectangle.WidthProperty, myControllableClock);

                //Adding ColorAnimation in the BackgroundProperty
                ColorAnimation ca = new ColorAnimation(Colors.Blue, new Duration(TimeSpan.FromSeconds(4)));
                c1Expander.Background = new SolidColorBrush(Colors.Red);
                c1Expander.Background.BeginAnimation(SolidColorBrush.ColorProperty, ca);
            }
            else
            {
                DoubleAnimation PosAnimation = new DoubleAnimation(200, 100, new Duration(TimeSpan.FromSeconds(5)));
                PosAnimation.SpeedRatio = 3;
                PosAnimation.AutoReverse = true;
                // Create a clock from the animation.
                var myControllableClock = PosAnimation.CreateClock();
                // Apply the clock to the rectangle's Width property.
                c1Expander.ApplyAnimationClock(Rectangle.HeightProperty, myControllableClock);
            }
        }

        private void AnimateHeightBtn_Click(object sender, RoutedEventArgs e)
        {
            DoubleAnimation doubleAnimation;

            //Applying Animation on the HeightProperty
            if (c1Expander.Height == 200)
            {
                doubleAnimation = new DoubleAnimation(21, new Duration(TimeSpan.FromSeconds(.7)), FillBehavior.HoldEnd);
            }
            else
            {
                doubleAnimation = new DoubleAnimation(200, new Duration(TimeSpan.FromSeconds(.7)), FillBehavior.HoldEnd);
            }
            c1Expander.BeginAnimation(C1.WPF.Extended.C1ExpanderButton.HeightProperty, doubleAnimation);

        }

        private void AnimateWidthBtn_Click(object sender, RoutedEventArgs e)
        {
            DoubleAnimation doubleAnimation;

            //Applying Animation on the WidthProperty
            if (c1Expander.Width > 200)
            {
                doubleAnimation = new DoubleAnimation(c1Expander.Width / 2, new Duration(TimeSpan.FromSeconds(.7)), FillBehavior.HoldEnd);
            }
            else
            {
                doubleAnimation = new DoubleAnimation(c1Expander.Width * 2, new Duration(TimeSpan.FromSeconds(.7)), FillBehavior.HoldEnd);
            }
            c1Expander.BeginAnimation(C1.WPF.Extended.C1ExpanderButton.WidthProperty, doubleAnimation);

        }
    }
}

